JavaScript实验:异常捕捉

与Java语言相同,JavaScript可以通过throw语句来抛出异常。与Java语言不同的是,JavaScript中可以通过throw语句抛出所有类型的值,而不仅止于抛出错误对象。

//Throw an Error object.
try{  
  throw new Error("Message in Error Object");
}catch(e){
    console.log(e);//Error: Message in Error Object
}

try{  
  throw "Raw Message";
}catch(message){
  console.log(message);//Raw Message
  console.log(typeof message);//string
}

try{  
  throw 42;
}catch(code){
  console.log(code);//42
  console.log(typeof code);//number
}

与Java语言一样,如果异常没有被任何catch语句所捕捉,那么该异常会最终抛给用户:

try{  
  //throw new Error("test error");//Error will be thrown. Error: test error
}finally{
}

try{  
  throw 42;//Error will be thrown. Error: 42
}finally{
}

对于抛出异常的捕捉,JavaScript使用的也是try/catch/finally语句,其使用规则为:try是必需的,catch和finally均为可选语句,但catch和finally中必须至少出现一个。

在catch语句中,可以定义一个参数e(或者其它任何合法的变量名),用于存储抛出的异常值。在catch语句内部,这个参数可以作为局部变量而使用。与JavaScript中其它的变量使用情况不同的是,catch语句中的参数变量仅在catch语句内部有效(该变量的作用域局限在catch语句中)。

对于finally语句,无论try中是否有异常抛出,finally中的代码均会被执行。详细情况包括:

  1. try中无异常发生,当try语句执行完毕后,finnally中的代码将被执行。
  2. try中无异常发生,但由于执行了break、continue或return语句而导致退出try代码时,finally中的代码将被执行。
  3. try中发生异常,异常由catch语句处理完成后,finally中的代码被执行。
  4. try中发生异常,但因没有catch语句导致该异常需要继续向上抛出时,finally中的代码将被执行。值得注意的是,在catch语句缺失的情况下,JavaScript将先执行finally中的代码,然后才向上继续抛出异常。

在finally代码中,如果出现break、continue或return语句,那么JavaScript将直接执行这些语句,而置try代码中可能存在的break、continue或return语句于不顾;即使catch语句缺失导致有异常需要上报,JS也会丢弃这个异常上报信息,继续执行finally代码中的break、continue或return语句。类似的,如果finally代码中也抛出了异常,那么JavaScript将丢弃所有try代码中的break、continue或return语句,同时也丢弃可能存在的异常上报行为,只抛出finally代码中的异常。

本文实验代码: http://jsfiddle.net/cshao/85wcz/

Chuan Shao

Read more posts by this author.

Shanghai

Subscribe to Chuan's blog

Get the latest posts delivered right to your inbox.

or subscribe via RSS with Feedly!